<template>
    <div
        class="w-full px-2 py-4"
    >
        <auto-form
            ref="form"
            :default-data="{
                name: $user.name,
                email: $user.email,
                contact_country_id: $user.contact_country_id,
                contact_number: $user.contact_number
            }"
            :password2-verify="true"
            :fields="formFields"
        />
        <div>
            <auto-button
                type="primary"
                block
                :disabled="form && form.busy ? form.busy : false"
                @click="submitForm"
            >
                {{ $t('apply_changes') }}
            </auto-button>
        </div>
    </div>
</template>
<script setup>
import {computed, inject, onMounted, ref} from "vue";
import AutoForm from "~/components/auto-form.vue";
import {useI18n} from "vue-i18n";
import AutoButton from "~/components/button/auto-button.vue";
import {useUserStore} from "~/stores/user.js";
import {useSettingStore} from "~/stores/setting.js";

const $helper = inject('$helper');
const i18n = useI18n();
const form = ref();
const formFields = ref([
    {
        type: 'text',
        name: 'name',
        label: i18n.t('name'),
        dark: true,
        size: 'lg',
    },
    {
        type: 'email',
        name: 'email',
        label: i18n.t('email'),
        dark: true,
        size: 'lg',
    },
    {
        type: 'contact',
        label: i18n.t('contact_number'),
        dark: true,
        size: 'lg',
    }
]);

const $userStore = useUserStore();
const submitForm = async () => {
    try {
        await form.value.submitForm('/profile_submit', async (resp) => {
            await $helper.alertSuccess({
                message: resp.message,
                callback: async () => {
                    await $userStore.fetchAccount();
                }
            });
        });
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    await $userStore.fetchAccount();
});
</script>
